/*
 *  ALTerator - ALT Linux configuration project
 *
 *  Copyright (c) 2004,2005 ALT Linux Ltd.
 *  Copyright (c) 2004,2005 Alexey Voinov
 *  Copyright (c) 2004,2005 Stanislav Ievlev
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */
#include <bus/console.hh>
#include <bus/ctrlc.hh>
#include <bus/proto.hh>

#include <iostream>
#include <string>

int
main(int argc, char *argv[])
{
//	ctrlc_init();
	console_init(std::cin, std::cout, argc, argv);

	try
	{
		while(console(std::cin, std::cout))
		{
			try
			{
				run();
			}
			catch(const err::proto& x)
			{
				std::cout << "error: " << x.why() << std::endl;
			}
			catch(const err::ctrlc&)
			{
				std::cout << "ctrl-c pressed" << std::endl;
			}
		}
	}
	catch(const err::finish&)
	{
	    std::cout << "exit bus" << std::endl;
	}

	bus_finit();
	return 0;
}
